This folder contains the code to reproduce the results of the paper
"Approximate Dec-POMDP Solving Using Multi-Agent A*" (IJCAI 2024).

`decPOMDP.py' is the main code file containing the solver. 
`decPOMDPverify.py' provides an independent verification of the value of any policies found. 
`decPOMDPrandom.py' computes the value of the random policy. 

The solvers can be called using the benchmark files, `python <benchmark>.py'. (For the results, we used pypy rather than python). 
The provided benchmarks are: box, broadcast, fireFight3houses, grid, grid3x3, hotel, mars, recycling and tiger. 
The syntax for calling the benchmarks is:

```
usage: <benchmark>.py [-h] [--cluster_type CLUSTER_TYPE] [--maxit MAXIT] [--q_depth Q_DEPTH]
                      [--alpha ALPHA] [--iter_limit ITER_LIMIT] [--maxrec MAXREC] [--memory MEMORY]
                      [--heuristic HEURISTIC] [--rec_type REC_TYPE] [--agents AGENTS]
                      [--policyvalfound POLICYVALFOUND] [--p_threshold_cluster P_THRESHOLD_CLUSTER]
                      [--p_threshold_expand P_THRESHOLD_EXPAND] [--output] [--random]
                      horizon
```

There are also several bash scripts that automate calling the benchmarks with particular parameters. 
The `benchmark_commands.txt' file in the utils folder contain the commands that should be called to reproduce the results. 
After organizing the results files in folders `results_policyfinder', `results_upper', `results_rsmaa' and `results_random',
one can use the `table.py' program to generate the tables in the main text and supplementary material. 
Finally, `cluster_table.py' generates the table in the empirical study of clustering (from the supplementary material).

