#!/bin/bash

niter=200;       # M in the RS-MAA* paper
dmin=3;          # d in the RS-MAA* paper
alpha=inf;       # alpha in the RS-MAA* paper
TL=600;          # time limit
CL=$3;           # clustering type
memory=$1;       # k in the paper
iter_limit=$2;   # L in the paper

for h in 4 5 6 7 8 9 10 12 15 20 30 40 50 100;
do
    echo "box" $h  $SECONDS;
    timeout $TL pypy3 box.py $h --cluster_type $CL --memory $memory --heuristic MDP --iter_limit $iter_limit;
done

for h in 4 5 6 7 8 9 10 12 15 20 30 40 50 100;
do
    echo "mars" $h  $SECONDS;
    timeout $TL pypy3 mars.py $h --cluster_type $CL --memory $memory --heuristic MDP --iter_limit $iter_limit;
done

for h in 4 5 6 7 8 9 10 12 15 20 30 40 50 100;
do
    echo "tiger" $h  $SECONDS;
    timeout $TL pypy3 tiger.py $h --cluster_type $CL --memory $memory --heuristic MDP --iter_limit $iter_limit;
done

for h in 4 5 6 7 8 9 10 12 15 20 50 100;
do
    echo "grid" $h  $SECONDS;
    timeout $TL pypy3 grid.py $h --cluster_type $CL --memory $memory --heuristic MDP --iter_limit $iter_limit;
done

for h in 4 5 6 7 8 9 10 12 15 20 30 40 50 100;
do
    echo "grid3x3" $h  $SECONDS;
    timeout $TL pypy3 grid3x3.py $h --cluster_type $CL --memory $memory --heuristic MDP --iter_limit $iter_limit;
done

for h in 100 500 1000 2000;
do
    echo "hotel" $h  $SECONDS;
    timeout $TL pypy3 hotel.py $h --cluster_type $CL --memory $memory --heuristic MDP --iter_limit $iter_limit;
done

for h in 100 500 1000 2000;
do
    echo "recycling" $h  $SECONDS;
    timeout $TL pypy3 recycling.py $h --cluster_type $CL --memory $memory --heuristic MDP --iter_limit $iter_limit;
done

for h in 100 500 1000 2000;
do
    echo "broadcast" $h  $SECONDS;
    timeout $TL pypy3 broadcast.py $h --cluster_type $CL --memory $memory --heuristic MDP --iter_limit $iter_limit;
done

for h in 4 5 6 10 100 2000;
do
    echo "fireFight" $h  $SECONDS;
    timeout $TL pypy3 fireFight.py $h --cluster_type $CL --memory $memory --heuristic MDP --iter_limit $iter_limit;
done

echo "time" $SECONDS;

