from decPOMDPrun import run
import parser_decPOMDP
import sys, time
from array import array
sys.setrecursionlimit(10000)

time1 = time.time()

parser = parser_decPOMDP.parse()
horizon = parser.horizon

nagentsBroadcast = 2
states1 = 2
nstatesBroadcast = 4 #[0, 1]
actBroadcast1 = 2 #[wait, send]
nactsBroadcast = actBroadcast1 ** nagentsBroadcast
nacts_factorBroadcast = [actBroadcast1, actBroadcast1]
obsBroadcast1 = 2 #[nocollision, collision]
nobsBroadcast = obsBroadcast1 ** nagentsBroadcast
nobs_factorBroadcast = [obsBroadcast1, obsBroadcast1]
transitBroadcast = [(array("i", []), array("d", [])) for _ in range(nstatesBroadcast*nactsBroadcast)]
obsBroadcast = [(array("i", []), array("d", [])) for _ in range(nstatesBroadcast*nactsBroadcast)]
rewardBroadcast = [0.0]*(nstatesBroadcast*nactsBroadcast)

p_message = [0.9, 0.1]
for act in range(nactsBroadcast):
    act_arr = [act//(actBroadcast1**i)%actBroadcast1 for i in range(nagentsBroadcast)]
    for s in range(nstatesBroadcast):
        s_arr = [s//(states1**i)%states1 for i in range(nagentsBroadcast)]
        for snew in range(nstatesBroadcast):
            snew_arr = [snew//(states1**i)%states1 for i in range(nagentsBroadcast)]
            pr = 1
            for n in range(nagentsBroadcast):
                if s_arr[n] == 0 or act_arr[n] == 1:
                    if snew_arr[n] == 0: pr *= (1 - p_message[n])
                    else: pr *= p_message[n]
                elif snew_arr[n] == 0: pr=0; break
            if pr != 0:
                transitBroadcast[act*nstatesBroadcast+s][0].append(snew)
                transitBroadcast[act*nstatesBroadcast+s][1].append(pr)


for act in range(nactsBroadcast):
    act_arr = [act//(actBroadcast1**i)%actBroadcast1 for i in range(nagentsBroadcast)]
    for s in range(nstatesBroadcast):
        s_arr = [s//(states1**i)%states1 for i in range(nagentsBroadcast)]
        for o in range(nobsBroadcast):
            o_arr = [o//(obsBroadcast1**i)%obsBroadcast1 for i in range(nagentsBroadcast)]
            if act_arr[0] == 1 and act_arr[1] == 1:
                if o_arr[0] == 0 and o_arr[1] == 0: pr = 0.01
                if o_arr[0] == 1 and o_arr[1] == 0: pr = 0.09
                if o_arr[0] == 0 and o_arr[1] == 1: pr = 0.09
                if o_arr[0] == 1 and o_arr[1] == 1: pr = 0.81
            else:
                if o_arr[0] == 0 and o_arr[1] == 0: pr = 0.81
                if o_arr[0] == 1 and o_arr[1] == 0: pr = 0.09
                if o_arr[0] == 0 and o_arr[1] == 1: pr = 0.09
                if o_arr[0] == 1 and o_arr[1] == 1: pr = 0.01
            
            if pr != 0:
                obsBroadcast[act*nstatesBroadcast+s][0].append(o)
                obsBroadcast[act*nstatesBroadcast+s][1].append(pr)

for act in range(nactsBroadcast):
    act_arr = [act//(actBroadcast1**i)%actBroadcast1 for i in range(nagentsBroadcast)]
    for s in range(nstatesBroadcast):
        s_arr = [s//(states1**i)%states1 for i in range(nagentsBroadcast)]
        if act_arr[0]+act_arr[1] == 1 and act_arr[0]*s_arr[0]+act_arr[1]*s_arr[1] == 1:
            rewardBroadcast[act*nstatesBroadcast+s] = 1
            

init_beliefsBroadcast = [0.0]*nstatesBroadcast
init_beliefsBroadcast[3] = 1.0 # both message
   
run(nagentsBroadcast, nstatesBroadcast, nactsBroadcast, nobsBroadcast,
    transitBroadcast, obsBroadcast, rewardBroadcast, init_beliefsBroadcast,
    nacts_factorBroadcast, nobs_factorBroadcast, horizon, parser, time1)




