from decPOMDPrun import run
import parser_decPOMDP
import sys, time
from array import array
sys.setrecursionlimit(10000)

time1 = time.time()

parser = parser_decPOMDP.parse()
horizon = parser.horizon

nagentsMars = 2
nstatesMars = 256
actMars1 = 6
nactsMars = actMars1 ** nagentsMars
nacts_factorMars = [actMars1, actMars1]
obsMars1 = 8
nobsMars = obsMars1 ** nagentsMars
nobs_factorMars = [obsMars1, obsMars1]
transitMars = [(array("i", []), array("d", [])) for _ in range(nstatesMars*nactsMars)]
obsMars = [(array("i", []), array("d", [])) for _ in range(nstatesMars*nactsMars)]
rewardMars = [0.0]*(nstatesMars*nactsMars)

data = open("data/mars.data")
for line in data:
    d = line.split()
    if d[0][0] == "T":
        act = int(d[1]) + actMars1*int(d[2])
        s = int(d[4])
        snew = int(d[6])
        transitMars[act*nstatesMars+s][0].append(snew)
        transitMars[act*nstatesMars+s][1].append(float(d[8]))
    elif d[0][0] == "O":
        act = int(d[1]) + actMars1*int(d[2])
        s = int(d[4])
        o = int(d[6]) + obsMars1*int(d[7])
        obsMars[act*nstatesMars+s][0].append(o)
        obsMars[act*nstatesMars+s][1].append(float(d[9]))
    elif d[0][0] == "R":
        act = int(d[1]) + actMars1*int(d[2])
        s = int(d[4])
        rewardMars[act*nstatesMars+s] = float(d[10])

init_beliefsMars = [0.0]*nstatesMars
init_beliefsMars[0] = 1.0
   
run(nagentsMars, nstatesMars, nactsMars, nobsMars,
    transitMars, obsMars, rewardMars, init_beliefsMars, nacts_factorMars, nobs_factorMars, 
    horizon, parser, time1)
    

