import os

names = ["tiger", "grid", "box", "fireFight", "grid3x3", "mars", "hotel", "recycling", "broadcast"]
names_tab = {"tiger":"\\dectiger", "grid":"\\grid", "box":"\\boxpush", "grid3x3": "\\gridthree", "mars":"\\mars", "hotel":"\\hotel", 
             "recycling":"\\recycling", "broadcast":"\\broadcast", "fireFight":"\\ff"}
formatter = {"tiger":".2f", "grid":".3f", "box":".2f", "grid3x3": ".2f", "mars":".2f", "hotel":".1f", 
             "recycling":".2f", "broadcast":".2f", "fireFight":".3f"}
formatter_maintext = {"tiger":".1f", "grid":".2f", "box":".1f", "grid3x3": ".1f", "mars":".1f"}

def print_value(name, val, maintext = False):
    if val != None:
        if val == "MLE": print(end = "MO & ")
        elif val == "TLE": print(end = "TO & ")
        elif val == "RE": print(end = "- & ")
        elif maintext: 
            if val < 0: print(" \\textminus ", end='')
            print(format(abs(val), formatter_maintext[name]), end=" & ",sep='')
        else: 
            if val < 0: print(" \\textminus ", end='')
            print(format(abs(val), formatter[name]), end=" & ",sep='')
    else: print(end=" & ")
    
def print_time(val, end = False):
    if val != None:
        if val == "MLE": print(end = "MO & ")
        elif val == "TLE": print(end = "TO & ")
        else:
            res = int(val+0.5)
            if res == 0: res = "\\textless 1"
            print(res, end=" \\\\" if end else " & ")
    else: print(end=" \\\\" if end else " & ")

output_bash_UB = True

time_results = dict()
value_results = dict()
result_types = ["1_1_mdp", "2_1_mdp", "3_1_mdp", "2_2_mdp", "3_2_mdp", "3_3_maxr", "3_MDP", "2_MDP"]
for res_type in result_types:
    time_results[res_type] = {k:dict() for k in names}
    value_results[res_type] = {k:dict() for k in names}

mdp_val = {k:dict() for k in names}
results_random  = {k:dict() for k in names}


value_results_fbhsvi = {
    "tiger":{"6":10.381, "7":9.9935, "8":12.217, "9":15.572, "10":15.184, "20":28.75, "30":51.90, "40":67.09, "50":80.66, "100": 170.90}, 
    "grid3x3":{"5":0.894, "6":1.491, "7":2.19, "8":2.96, "9":3.80, "10":4.68, "20":14.35, "30":24.33, "40":34.33, "50":44.32, "100":94.24},
    "broadcast":{"100":90.76, "1000": 903.28}, "grid":{"4":2.24, "5":2.97,"6":3.71,"7":4.47,"8":5.23,"9":6.03}, "recycling":{"100":308.78},
    "box":{"4":98.593, "5":107.72, "6":120.67, "7":156.42, "8":191.22, "9":210.27, "10":223.74, "20":458.10, "30":636.28, "40":774.14, "50":1134.70}, 
    "mars": {"5": 13.26, "6": 18.62, "7":20.90, "8":22.47, "9":24.31, "10":26.31, "20":52.13, "30":78.09, "40":103.52, "50":128.95, "100": 249.92}}
value_results_fbhsvi_epsopt = {"tiger":{"6":10.381, "7":9.9935, "8":12.217, "9":15.572, "10":15.184}, 
    "recycling":{"100":308.78}, "grid3x3":{"5":0.894, "6":1.491, "7":2.19, "8":2.96, "9":3.80, "10":4.68, "20":14.35, "30":24.33},
    "broadcast":{"100":90.76}, "grid":{"4":2.24, "5":2.97,"6":3.71,"7":4.47,"8":5.23,"9":6.03}, 
    "box":{"4":98.593, "5":107.72, "6":120.67, "7":156.42, "8":191.22, "9":210.27, "10":223.74}, 
    "mars": {"5": 13.26, "6": 18.62, "7":20.90, "8":22.47, "9":24.31, "10":26.31}}
value_results_gafsc = {"tiger":{"6":10.381, "8":8.00, "10":13.57, "100": 169.30}, 
    "recycling":{"100":308.79}, "broadcast":{"100":90.29, "500":450.29, "1000": 900.29}, "grid":{"4":2.24,"5":2.97,"6":3.72,"50":40.49}, 
    "box":{"4":98.17, "8":189.05, "10":216.98, "20":468.15, "50":1201.05, "100": 2420.26}, "fireFight":{"4":-6.58,"5":-7.07,"6":-7.18}} 
minresults = 1
timeout = 600
timeoutUB = 1800

directory = "./results_policyfinder"
for filename in os.listdir(directory):
    f = os.path.join(directory, filename)

    if os.path.isfile(f) and f[-4:]==".out":
         data = open(f)
         time = None
         time_new = 0
         l2 = data.readline().split()
         
         if "1_mdp" in filename: timeout = 60  
         else: timeout = 600
         for res_type in result_types:
             if res_type in filename:
                 rtype = res_type
                 break
         
         while True:
            if l2[0] == "time": break
            name = l2[0]
            h = l2[1]

            l2 = data.readline().split()
            if "1_mdp" in filename:
                mdp_val[name][h] = float(l2[0])
            while l2[0][0] == "-" or l2[0][0].isnumeric() or l2[0] == "heuristic":
                l2 = data.readline().split()
            
            if l2[0][:5] != "count":
                if len(l2) > 2 or l2[0] == "time":
                    time = time_new
                    time_new = int(l2[-1])
                    
                if time != None and time_new - time >= timeout: val = "TLE"
                elif time != None and ("3_1_mdp" in filename) and name == "mars": val = "RE"
                elif time != None and time_new - time < timeout: val = "MLE"
                res = time_new - time
                if res == timeout + 1:
                    res = timeout
                
                time_results[rtype][name][h] = res
                value_results[rtype][name][h] = val

            else:
                l2 = data.readline().split()
                if l2[0] == "warning:":
                    l2 = data.readline().split()
                val = round(float(l2[0][1:-1]), 8)
                
                data.readline()
                l2 = data.readline().split()
                res = float(l2[-1])
                
                time_results[rtype][name][h] = res
                value_results[rtype][name][h] = val
                
                l2 = data.readline().split()
                if len(l2) > 2:
                    time = time_new
                    time_new = int(l2[-1])

   # output bash code for upper bound benchmarks with found policyvalues
if output_bash_UB: 
    for name in names:  # fast results only
        a = list(time_results["1_1_mdp"][name].keys())
        a = [str(x) for x in sorted([int(x) for x in set(a)])]
    
        for h in a:
            values = [x for x in [value_results[rtype][name][h] for rtype in ["1_1_mdp", "2_1_mdp", "3_1_mdp"]] if isinstance(x, float)]
            if len(values) > 0: maxvalue = max(values) - 1e-6
            else: maxvalue = None
            
            print("echo \"", name, " ", h, "\" $SECONDS;", sep='')
            print("timeout $TL pypy3 ", name, ".py ", h, " --output --maxrec $maxrec --rec_type $rectype", sep='', end='')
            if maxvalue != None:
                print(" --policyvalfound ", format(maxvalue, ".6f"), ";", sep='')
            else: print(";")
    print("echo \"time\" $SECONDS;")    
    
    print()

    for name in names:  # quality results
        a = list(time_results["2_2_mdp"][name].keys())
        a = [str(x) for x in sorted([int(x) for x in set(a)])]
    
        for h in a:
            values = [x for x in [value_results[rtype][name][h] for rtype in ["2_2_mdp", "3_2_mdp", "3_3_maxr"]] if isinstance(x, float)]
            if len(values) > 0: maxvalue = max(values) - 1e-6
            else: maxvalue = None

            print("echo \"", name, " ", h, "\" $SECONDS;", sep='')            
            print("timeout $TL pypy3 ", name, ".py ", h, " --output --maxrec $maxrec --rec_type $rectype", sep='', end='')
            if maxvalue != None:
                print(" --policyvalfound ", format(maxvalue, ".6f"), ";", sep='')
            else: print(";")
    print("echo \"time\" $SECONDS;")
    
    print()
    
    for name in names:  # fast results only
        a = list(time_results["1_1_mdp"][name].keys())
        a = [str(x) for x in sorted([int(x) for x in set(a)])]
    
        for h in a:
            values = [x for x in [value_results[rtype][name][h] for rtype in ["1_1_mdp", "2_1_mdp", "3_1_mdp"]] if isinstance(x, float)]
            if len(values) > 0: maxvalue = max(values) - 1e-6
            else: maxvalue = None
            
            print("echo \"", name, " ", h, "\" $SECONDS;", sep='')
            print("timeout $TL pypy3 ", name, ".py ", h, " --output  --maxit $1 --q_depth $2 --alpha 0.2", sep='', end='')
            if maxvalue != None:
                print(" --policyvalfound ", format(maxvalue, ".6f"), ";", sep='')
            else: print(";")
    print("echo \"time\" $SECONDS;")    
    
    print()

    for name in names:  # quality results
        a = list(time_results["2_2_mdp"][name].keys())
        a = [str(x) for x in sorted([int(x) for x in set(a)])]
    
        for h in a:
            values = [x for x in [value_results[rtype][name][h] for rtype in ["2_2_mdp", "3_2_mdp", "3_3_maxr"]] if isinstance(x, float)]
            if len(values) > 0: maxvalue = max(values) - 1e-6
            else: maxvalue = None

            print("echo \"", name, " ", h, "\" $SECONDS;", sep='')            
            print("timeout $TL pypy3 ", name, ".py ", h, " --output --maxit $1 --q_depth $2 --alpha 0.2", sep='', end='')
            if maxvalue != None:
                print(" --policyvalfound ", format(maxvalue, ".6f"), ";", sep='')
            else: print(";")
    print("echo \"time\" $SECONDS;")
            
time_results_upper = {k:dict() for k in names}
value_results_upper = {k:dict() for k in names}
exact_results_upper = {k:dict() for k in names}
time_results_upper_fast = {k:dict() for k in names}
value_results_upper_fast = {k:dict() for k in names}
exact_results_upper_fast = {k:dict() for k in names}

directory = "./results_upper"
for filename in os.listdir(directory):
    f = os.path.join(directory, filename)

    if os.path.isfile(f) and f[-4:]==".out":
         data = open(f)
         time = None
         time_new = 0
         l2 = data.readline().split()
         
         if "fast" in filename: timeoutUB = 120
         else: timeoutUB = 1800
         
         while True:
            if l2[0] == "time": break
            name = l2[0]
            h = l2[1]
            
            l2 = data.readline().split()
            while l2[0][0] == "-" or l2[0][0].isnumeric() or l2[0] == "heuristic" or l2[0] == "inf":
                l2prev = l2
                l2 = data.readline().split()
            
            if l2[0][:5] != "count":
                if len(l2) > 2 or l2[0] == "time":
                    time = time_new
                    time_new = int(l2[-1])
                
                res = time_new - time
                if res == timeoutUB + 1: 
                    res = timeoutUB

                if len(l2prev)>1 and l2prev[0] != "heuristic": val = float(l2prev[0])
                elif time != None and res >= timeoutUB: val = "TLE"
                elif time != None and res < timeoutUB: val = "MLE"
                
                if "fast" in filename:
                    time_results_upper_fast[name][h] = res
                    value_results_upper_fast[name][h] = val
                else:
                    time_results_upper[name][h] = res
                    value_results_upper[name][h] = val
                
            else:
                l2 = data.readline().split()
                val = round(float(l2[0][1:-1]), 8)
                
                data.readline()
                l2 = data.readline().split()
                res = float(l2[-1])
                
                if "fast" in filename:
                    time_results_upper_fast[name][h] = res
                    value_results_upper_fast[name][h] = val
                    exact_results_upper_fast[name][h] = True
                else:
                    time_results_upper[name][h] = res
                    value_results_upper[name][h] = val
                    exact_results_upper[name][h] = True
                
                l2 = data.readline().split()
                if len(l2) > 2:
                    time = time_new
                    time_new = int(l2[-1])
                    
                    
time_results_upper_rsmaa = {k:dict() for k in names}
value_results_upper_rsmaa = {k:dict() for k in names}
exact_results_upper_rsmaa = {k:dict() for k in names}
time_results_upper_rsmaa_fast = {k:dict() for k in names}
value_results_upper_rsmaa_fast = {k:dict() for k in names}
exact_results_upper_rsmaa_fast = {k:dict() for k in names}

directory = "./results_rsmaa"
for filename in os.listdir(directory):
    f = os.path.join(directory, filename)

    if os.path.isfile(f) and f[-4:]==".out":
         data = open(f)
         time = None
         time_new = 0
         l2 = data.readline().split()
         
         if "fast" in filename: timeoutUB = 120
         else: timeoutUB = 1800
         
         while True:
            if l2[0] == "time": break
            name = l2[0]
            h = l2[1]
            foundbound = False

            l2 = data.readline().split()
            while l2[0][0] == "-" or l2[0][0].isnumeric() or l2[0] == "heuristic"  or l2[0] == "inf":
                foundbound = True
                l2prev = l2
                l2 = data.readline().split()
            
            if l2[0][:5] != "count":
                if len(l2) > 2 or l2[0] == "time":
                    time = time_new
                    time_new = int(l2[-1])
                
                res = time_new - time
                if res == timeoutUB + 1: 
                    res = timeoutUB
                if foundbound: val = float(l2prev[0])
                elif time != None and res >= timeoutUB: val = "TLE"
                elif time != None and res < timeoutUB: val = "MLE"
                
                if "fast" in filename:
                    dh = time_results_upper_rsmaa_fast[name].get(h)
                    if dh == None: 
                        time_results_upper_rsmaa_fast[name][h] = []
                        value_results_upper_rsmaa_fast[name][h] = []
                    time_results_upper_rsmaa_fast[name][h].append(res)
                    value_results_upper_rsmaa_fast[name][h].append(val)
                else:
                    dh = time_results_upper_rsmaa[name].get(h)
                    if dh == None: 
                        time_results_upper_rsmaa[name][h] = []
                        value_results_upper_rsmaa[name][h] = []
                    time_results_upper_rsmaa[name][h].append(res)
                    value_results_upper_rsmaa[name][h].append(val)
                
            else:
                l2 = data.readline().split()
                val = round(float(l2[0][1:-1]), 8)
                
                data.readline()
                l2 = data.readline().split()
                res = float(l2[-1])
                
                if "fast" in filename:
                    dh = time_results_upper_rsmaa_fast[name].get(h)
                    if dh == None: 
                        time_results_upper_rsmaa_fast[name][h] = []
                        value_results_upper_rsmaa_fast[name][h] = []
                    time_results_upper_rsmaa_fast[name][h].append(res)
                    value_results_upper_rsmaa_fast[name][h].append(val)
                    exact_results_upper_rsmaa_fast[name][h] = True
                else:
                    dh = time_results_upper_rsmaa[name].get(h)
                    if dh == None: 
                        time_results_upper_rsmaa[name][h] = []
                        value_results_upper_rsmaa[name][h] = []
                    time_results_upper_rsmaa[name][h].append(res)
                    value_results_upper_rsmaa[name][h].append(val)
                    exact_results_upper_rsmaa[name][h] = True
                
                l2 = data.readline().split()
                if len(l2) > 2:
                    time = time_new
                    time_new = int(l2[-1])


for name in names:  # compute the best results for rsmaa
    for h in time_results_upper_rsmaa[name]:
        if any([isinstance(val, float) and val != float("inf") for val in value_results_upper_rsmaa[name][h]]):
            val_min = min([val for val in  value_results_upper_rsmaa[name][h] if isinstance(val, float)])
            time = min([time_results_upper_rsmaa[name][h][idx] for idx in range(len(time_results_upper_rsmaa[name][h])) 
                          if isinstance(value_results_upper_rsmaa[name][h][idx], float) and abs(value_results_upper_rsmaa[name][h][idx]-val_min)<1e-8])
            time_results_upper_rsmaa[name][h] = time
            value_results_upper_rsmaa[name][h] = val_min
        else: 
            time_results_upper_rsmaa[name][h] = min(time_results_upper_rsmaa[name][h])
            value_results_upper_rsmaa[name][h] = "MLE" if (time_results_upper_rsmaa[name][h] < 1800) else "TLE"
        if any([isinstance(val, float) and val != float("inf")  for val in value_results_upper_rsmaa_fast[name][h]]):
            val_min = min([val for val in  value_results_upper_rsmaa_fast[name][h] if isinstance(val, float)])
            time = min([time_results_upper_rsmaa_fast[name][h][idx] for idx in range(len(time_results_upper_rsmaa_fast[name][h])) 
                          if isinstance(value_results_upper_rsmaa_fast[name][h][idx], float) and abs(value_results_upper_rsmaa_fast[name][h][idx]-val_min)<1e-8])
            time_results_upper_rsmaa_fast[name][h] = time
            value_results_upper_rsmaa_fast[name][h] = val_min
        else: 
            time_results_upper_rsmaa_fast[name][h] = min(time_results_upper_rsmaa_fast[name][h])
            value_results_upper_rsmaa_fast[name][h] = "MLE" if (time_results_upper_rsmaa_fast[name][h] < 120) else "TLE"
            

directory = "./results_random"
for filename in os.listdir(directory):
    f = os.path.join(directory, filename)

    if os.path.isfile(f) and f[-4:]==".out":
         data = open(f)
         l2 = data.readline().split()
        
         while True:
            if l2[0] == "time": break
            name = l2[0]
            h = l2[1]
            results_random[name][h] = float(data.readline())
            l2 = data.readline().split()


skip = [("tiger",4), ("tiger",5), ("grid3x3",4), ("mars",4), ("mars",5)]
select_LB = [("tiger",x) for x in [20, 50, 100]] + [("grid",x) for x in [7,10,20,50]] + [("box",x) for x in [10,20,50,100]] + [("mars", x) for x in [10,20,50,100]]
select_UB =  [("grid",x) for x in [7,10,20,50]] + [("box",x) for x in [10,20,50,100]] + [("mars", x) for x in [10,20,50,100]]

# all lower bounds
print("\\begin{table}[h!]")
print("\\resizebox{\\columnwidth}{!}{")
print("\\begin{tabular}{@{}r|rr|rr|rr|rr|rr|rr@{}} \\hline")
print("& \\multicolumn{2}{|c}{1,$Q_{\\mathsf{MDP},1}$,20} & \\multicolumn{2}{|c}{2,$Q_{\\mathsf{MDP},1}$,100} & \\multicolumn{2}{|c}{3,$Q_{\\mathsf{MDP},1}$,100} & \\multicolumn{2}{|c}{2,$Q_{\\mathsf{MDP},2}$,$10^3$} & \\multicolumn{2}{|c}{3,$Q_{\\mathsf{MDP},2}$,$10^4$} & \\multicolumn{2}{|c}{3,$Q_{\\mathsf{maxr},3}$,$10^4$} \\\\ \\hline")
print("$h$ & value & time & value & time & value & time & value & time & value & time & value & time \\\\ \\hline")
for name in names:
    a = list(time_results["1_1_mdp"][name].keys())
    a = [str(x) for x in sorted([int(x) for x in set(a)])]
    print("\\multicolumn{13}{c}{", names_tab[name], "} \\\\ \\hline")
    
    for h in a:
        if (name, int(h)) in skip: continue
        print(h, end =" & ")
    
        for res_type in ["1_1_mdp", "2_1_mdp", "3_1_mdp", "2_2_mdp", "3_2_mdp", "3_3_maxr"]:
            print_value(name, value_results[res_type][name].get(h))
            print_time(time_results[res_type][name].get(h), end = (res_type == "3_3_maxr"))

        if h != a[-1]: print()
        else: print("\\hline")
            
print("\\end{tabular}")
print("}")
print("\\end{table}")
print("\\newpage")

# lower bound comparison table
print("\\begin{table}[h!]")
print("\\resizebox{\\columnwidth}{!}{")
print("\\begin{tabular}{@{}r|rr|rr|rr|rr|rr|rr@{}} \\hline")
print(" & FB-HSVI & GA-FSC & \\multicolumn{2}{|c}{2,$Q_{\\mathsf{MDP}}$,$10^3$} & \\multicolumn{2}{|c}{3,$Q_{\\mathsf{MDP}}$,$10^4$} & \\multicolumn{2}{|c}{\ourLB(f)} & \\multicolumn{2}{|c}{\ourLB} & random  & upper \\\\ \\hline")
print("$h$ & value & value & value & time & value & time & value & time & value & time & value & value \\\\ \\hline")
for name in names:
    a = list(time_results["1_1_mdp"][name].keys())
    a = [str(x) for x in sorted([int(x) for x in set(a)])]
    print("\\multicolumn{13}{c}{", names_tab[name], "} \\\\ \\hline")
    
    for h in a:
        if (name, int(h)) in skip: continue
        print(h, end =" & ")
        
        
        val =  value_results_fbhsvi.get(name,dict()).get(h)
        if val != None: print(format(val, ".2f"), end=" & ",sep='')
        else: print(end=" & ")
        
        val =  value_results_gafsc.get(name, dict()).get(h)
        if val != None: print(format(val, ".2f"), end=" & ",sep='')
        else: print(end=" & ")
        
        for res_type in ["2_MDP", "3_MDP"]:
            print_value(name, value_results[res_type][name].get(h))
            print_time(time_results[res_type][name].get(h))
        
        print_value(name, max([x for x in [value_results[rtype][name][h] for rtype in ["1_1_mdp", "2_1_mdp", "3_1_mdp"]] if isinstance(x, float)] or ["MLE"]))
        print_time(sum([time_results[rtype][name][h] for rtype in ["1_1_mdp", "2_1_mdp", "3_1_mdp"]]))

        print_value(name, max([x for x in [value_results[rtype][name][h] for rtype in ["2_2_mdp", "3_2_mdp", "3_3_maxr"]] if isinstance(x, float)] or ["MLE"]))
        print_time(sum([time_results[rtype][name][h] for rtype in ["2_2_mdp", "3_2_mdp", "3_3_maxr"]]))
        
        if float(results_random[name][h]) < 0: print(" \\textminus ", end='')
        print(format(abs(results_random[name][h]), formatter[name]), end=" & ",sep='')
        
        res = min([x for x in [mdp_val[name][h], value_results_upper_rsmaa[name][h], value_results_upper[name][h], value_results_upper_fast[name][h]] if isinstance(x, float)])
        print(format(res, formatter[name]), end=" \\\\ ")

        if h != a[-1]: print()
        else: print("\\hline")
            
print("\\end{tabular}")
print("}")
print("\\end{table}")
print("\\newpage")

# upper bound comparison table
print("\\begin{table}[h!]")
print("\\resizebox{\\columnwidth}{!}{")
print("\\begin{tabular}{@{}r|r|rr|rr|rr|rr|rr@{}} \\hline")
print("& FB-HSVI & \\multicolumn{2}{|c}{\\rsmaa(f)} & \\multicolumn{2}{|c}{\\rsmaa} & \\multicolumn{2}{|c}{\\ourUB(f)} & \\multicolumn{2}{|c|}{\\ourUB} & lower & MDP \\\\ \\hline")
print("$h$ & value & value & time & value & time & value & time & value & time & value & value \\\\ \\hline")
for name in names:
    a = list(time_results["1_1_mdp"][name].keys())
    a = [str(x) for x in sorted([int(x) for x in set(a)])]
    print("\\multicolumn{12}{c}{", names_tab[name], "} \\\\ \\hline")
    
    for h in a:
        if (name, int(h)) in skip: continue
        print(h, end =" & ")
    
        val =  value_results_fbhsvi_epsopt.get(name,dict()).get(h)
        if val != None:  # + 0.01 since epsilon = 0.01
            print(format(float(val)+0.01, ".2f"), end=" & ",sep='')
        else: print(end=" & ")

        print_value(name, value_results_upper_rsmaa_fast[name].get(h))
        print_time(time_results_upper_rsmaa_fast[name].get(h))
        print_value(name, value_results_upper_rsmaa[name].get(h))
        print_time(time_results_upper_rsmaa[name].get(h))
        print_value(name, value_results_upper_fast[name].get(h))
        print_time(time_results_upper_fast[name].get(h))
        print_value(name, value_results_upper[name].get(h))
        print_time(time_results_upper[name].get(h))
        
        print(format(max([x for x in [value_results[rtype][name][h] for rtype in result_types] + \
                         [value_results_fbhsvi.get(name,dict()).get(h), value_results_gafsc.get(name,dict()).get(h)] 
                if x is not None and isinstance(x, float)]), formatter[name]), end=" & ",sep='')
        
        print(format(mdp_val[name][h], formatter[name]), end=" \\\\ ")

        if h != a[-1]: print()
        else: print("\\hline")
            
print("\\end{tabular}")
print("}")
print("\\end{table}")
print("\\newpage")

# lower bound (selected)
print("\\begin{table}[h!]")
print("\\resizebox{\\columnwidth}{!}{")
print("\\begin{tabular}{@{}r|rrr|rr|rr@{}} \\hline")
print(" $h$ & FB-HSVI & GA-FSC & \multicolumn{3}{|c|}{\ourLB} & random & upper \\\\ \\hline")

for name in names:
    a = list(time_results["1_1_mdp"][name].keys())
    a = [str(x) for x in sorted([int(x) for x in set(a)])]
    print("\\multicolumn{8}{c}{", names_tab[name], "} \\\\ \\hline")
    
    for h in a:
        if (name, int(h)) not in select_LB: continue
        print(h, end =" & ")
    
        val = value_results_fbhsvi.get(name,dict()).get(h)
        if val != None: print(format(val, formatter_maintext[name]), end=" & ",sep='')
        else: print(end=" & ")
        
        val =  value_results_gafsc.get(name, dict()).get(h)
        if val != None: print(format(val, formatter_maintext[name]), end=" & ",sep='')
        else: print(end=" & ")

        print_value(name, max([x for x in [value_results[rtype][name][h] for rtype in ["2_MDP", "3_MDP"]] if isinstance(x, float)]), maintext = True)
        print_value(name, max([x for x in [value_results[rtype][name][h] for rtype in ["1_1_mdp", "2_1_mdp", "3_1_mdp"]] if isinstance(x, float)] or ["MLE"]), maintext = True)
        print_value(name, max([x for x in [value_results[rtype][name][h] for rtype in ["2_2_mdp", "3_2_mdp", "3_3_maxr"]] if isinstance(x, float)] or ["MLE"]), maintext = True)
        
        if float(results_random[name][h]) < 0: print(" \\textminus ", end='')
        print(format(abs(results_random[name][h]), formatter_maintext[name]), end=" & ",sep='')
        
        res = min([x for x in [mdp_val[name][h], value_results_upper_rsmaa[name][h], value_results_upper[name][h], value_results_upper_fast[name][h]] if isinstance(x, float)])
        print(format(res, formatter_maintext[name]), end=" \\\\ ")

        if h != a[-1]: print()
        else: print("\\hline")
            
print("\\end{tabular}")
print("}")
print("\\end{table}")

print("\\begin{table}[h!]")
print("\\resizebox{\\columnwidth}{!}{")

# upper bound comparison table
print("\\begin{tabular}{@{}r|rrr|rr|r@{}} \\hline")
print("$h$ & FB-HSVI & \multicolumn{2}{|c|}{\\rsmaa} & \multicolumn{2}{|c|}{\\ourUB} & lower & MDP \\\\ \\hline")
lines = 0
for name in names:
    a = list(time_results["1_1_mdp"][name].keys())
    a = [str(x) for x in sorted([int(x) for x in set(a)])]
    print("\\multicolumn{8}{c}{", names_tab[name], "} \\\\ \\hline")
    
    for h in a:
        if (name, int(h)) not in select_UB: continue
        print(h, end =" & ")
    
        val =  value_results_fbhsvi_epsopt.get(name,dict()).get(h)
        if val != None:  # + 0.01 since epsilon = 0.01
            print(format(float(val)+0.01, formatter_maintext[name]), end=" & ",sep='')
        else: print(end=" & ")

        print_value(name, value_results_upper_rsmaa_fast[name].get(h), maintext = True)
        print_value(name, value_results_upper_rsmaa[name].get(h), maintext = True)
        print_value(name, value_results_upper_fast[name].get(h), maintext = True)
        print_value(name, value_results_upper[name].get(h), maintext = True)
        
        print(format(max([x for x in [value_results[rtype][name][h] for rtype in result_types] + \
                         [value_results_fbhsvi.get(name,dict()).get(h), value_results_gafsc.get(name,dict()).get(h)] 
                if x is not None and isinstance(x, float)]), formatter_maintext[name]), end=" & ",sep='')
        
        print(format(mdp_val[name][h], formatter_maintext[name]), end=" \\\\ ")

        if h != a[-1]: print()
        else: print("\\hline")
            
print("\\end{tabular}")
print("}")
print("\\end{table}")
